      program seecmp24
      parameter(nmax0=4096,nch0=24) 
      character filen*80,filem*10
      real*4 x(nmax0,nch0),xx(nmax0),amaxacc(nch0),rr(nch0)
	integer irr(nch0)
c     character cdrv*3,cwkf*10
       character cdrv*2,cwkf*9
      data fac/0.71/ aym,x0,yl,DTL/38.0,2.5,0.5,0.05/
      data nbandp/0/ fl,fh,fs/2.,90.,100./ 
      data ap,as/0.1,10./ ntype,nchara0,ncausal/2,3,1/
c
c     data cdrv/'../'/ 
      data cdrv/'./'/ 
c working folder name
      cwkf=cdrv//'maswkf/'
c      cwkf=cdrv
      filen='./maswkf/prm/'//'seecmp24.prm'
      write(6,*)filen
      open(11,file=filen,status='old')
      read(11,*)ncmps,ncmpe,ncmpd,n_norm
      do i_mea=ncmps,ncmpe,ncmpd
c       read(11,*)filem
       if(i_mea.lt.10) then
        write(filem,'(a5,i1,a4)')'cmp00',i_mea,'.dat'
       else if(i_mea.lt.100) then
        write(filem,'(a4,i2,a4)')'cmp0',i_mea,'.dat'
       else if(i_mea.lt.1000) then
        write(filem,'(a3,i3,a4)')'cmp',i_mea,'.dat'
       else
        write(6,*)'cmp number should less than 1000.'
        stop
       endif
       filen='./maswkf/data/cmp_gathers/'//filem
       write(6,*)filen
       open(1,file=filen,status='old')
       read(1,'(i8,2f8.4,2i8)')icmp,x_cmp,dt,nn,nch
       write(6,'(i8,2f8.4,2i8)')icmp,x_cmp,dt,nn,nch
       do ich=1,nch0+1
        read(1,'(i8,4f8.3,i8)',end=10)irr(ich),rr(ich),x1,x_cmp,x2,nstack
        write(6,'(i8,4f8.3,i8)')irr(ich),rr(ich),x1,x_cmp,x2
c        write(6,*)irr(ich),rr(ich),x1,x_cmp,x2,nstack
        read(1,'(5e13.6)')(x(i,ich),i=1,nn)
       enddo
   10  nch=ich-1
       close(1)
c
       nst=1
       ned=nn
       if(nbandp.eq.1) then
        do ich=1,nch
         do i=1,nn
          xx(i)=x(i,ich)
         enddo
         call bandp1(xx,nn,dt,fl,fh,fs,ap,as,ntype,nchara0,ncausal)
         do i=1,nn
          x(i,ich)=xx(i)
         enddo
        enddo
       endif
c maximum value over each channel      
       do ich=1,nch
        amaxacc(ich)=abs(x(nst,ich))
        do i=nst+1,ned
         if(amaxacc(ich).lt.abs(x(i,ich))) then
          amaxacc(ich)=abs(x(i,ich))
         endif
        enddo
c        write(6,*)amaxacc(ich)
       enddo
c maximum value over all channels
       amaxx=amaxacc(1)
	 do ich=2,nch
        if(amaxx.lt.amaxacc(ich)) amaxx=amaxacc(ich)
       enddo
c normalize
       if(n_norm.eq.0) then
	  do ich=1,nch
	   do i=1,nn
	    x(i,ich)=1.8*x(i,ich)/amaxacc(ich)
         enddo
        enddo
	 else if(n_norm.eq.1) then
	  do ich=1,nch
	   do i=1,nn
	    x(i,ich)=1.8*x(i,ich)/amaxx
         enddo
        enddo
	 endif
c
       filen='./maswkf/data/cmp_gathers/fig/'//filem(1:6)//'.ps'
c       write(6,'(a)') filen
       open(25,file=filen,status='unknown')
ccccc
       CALL PLOTS(25)
c      call yoko(25) 
       CALL FACTOR(FAC)
       call plot(x0,0.,-3)
       CALL NEWPEN(1)
       ay=aym
       call symbol(0.0,36.,0.4,'Spacing(m)',90.0,10)
       call symbol(3.0,ay+1.5,0.8,filem,0.0,10)
       call symbol(10.0,ay+2.0,0.4,
     *         'Common Mid Point Gather(cross-correlation)',0.0,43)
       call symbol(10.0,ay+1.5,0.4,'Mid Point at           m',0.0,24)
       call number(13.6,ay+1.5,0.4,x_cmp,0.0,1)
       do ich=1,nch
	  do i=1,nn
         xx(i)=x(i,ich)
        enddo
c        call symbol(4.0,ay+yl+0.3,0.3,'Max=',0.0,4)
c        call number(5.5,ay+yl+0.3,0.3,amaxacc(ich),0.0,3)
        CALL PLOT( 2., AY,-3)
        call pltwv2(xx,nn,dt,dtl,1.,yl,rr(ich),ich,nch)
        CALL PLOT(-2.,-AY,-3)
        ay=ay-3.*yl
       enddo
       call plote(25)
       close(25)
ccccc
      enddo
	close(11)
c
      stop
      end
c
      include 'PSCAL.F'
      include 'dgflt.f'
c
      subroutine pltwv2(d,n,dt,dtl,YMAX,yl,rr,ich,nch)
      REAL*4 d(n)
      data htitle,hcha,htick/0.4,0.2,0.2/
      tlong=real(int(real(n)*dt/dtl)+1)
      ntlong=int(tlong)
      dsize=dt/dtl
      IF(YMAX.LT.1.0E-30) YMAX=1.0E-30
      call plot(   0.,0.,3)
      call plot(tlong,0.,2)
c      call plot(   0.,-yl,3)
c      call plot(tlong,-yl,2)
c      call plot(   0., yl,3)
c      call plot(tlong, yl,2)
      if(ich.eq.nch) then
      call symbol(0.5*tlong-htitle*1.5,
     *                  -(yl+htick*2.+htitle+0.1),htitle,'sec',0.0,3)
      endif
      do 10 i=0,ntlong
        call plot(real(i),-yl,3)
   10   call plot(real(i),-yl-htick,2)
      do 11 i=0,ntlong
        call plot(real(i),yl,3)
   11   call plot(real(i),yl+htick,2)
      if(ich.eq.nch) then
      do 12 i=0,ntlong,2
   12   call number(real(i)-hcha*2.,-(yl+htick+hcha+0.1),hcha,
     *              real(i)*dtl,0.0,1)
      endif
      DYL=YMAX/YL
      call plot(0.,-yl,3)
      call plot(0., yl,2)
c      do 110 i=-int(yl+0.5),int(yl+0.5)
c        call plot(-htick,real(i),3)
c        call plot(    0.,real(i),2)
c  110 continue      
      ncfra=3
      if(ymax.ge.  1.) then
       ncfra=4
       if(ymax.ge. 10.) then
        ncfra=5
        if(ymax.ge.100.) then
         ncfra=6
         if(ymax.ge.1000.) ncfra=7.
        endif
       endif
      endif
      xx=-(htick+hcha*real(ncfra)+0.1) 
      yy=yl+hcha*0.5
c      call number(xx,-yy,hcha,-ymax,0.0,3)
c      call number(-hcha*3.25,-hcha*0.5,hcha,0.0,0.0,1)
      call number(-hcha*6.5-.5,-hcha,hcha*2.,rr,0.0,1)
c      call number(xx, yy,hcha,ymax,0.0,3)
      call plot(tlong, yl,3)
      call plot(tlong,-yl,2)
      call plot(0.,d(1)/DYL,3)
      do  130  i=2,n
      Y=D(I)/DYL
      call plot((i-1)*dsize,Y,2)
      if(Y.ge.0.)	then
      call plot((i-1)*dsize,0.,2)
      call plot((i-1)*dsize,Y,3)
	endif
  130 continue
      return
      end
